function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { Button, Result } from 'antd';
import React, { useEffect, useState } from 'react';
import ColumnRuleList from '../../../../components/job/columnRuleList';
import { SimpleColumnTable } from '../../../../components/job/columnSelect';
import VisualStore from '../store';
import '../styles/tableConfig.less';
import ConfigLoading from './configLoading';
var TableConfig = function TableConfig(props) {
  var node = props.node;
  var nodeData = node.getData();
  var classPrefix = 'flow-table-config';
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    columnList = _useState2[0],
    setColumnList = _useState2[1];
  var _useState3 = useState(nodeData.columnList || []),
    _useState4 = _slicedToArray(_useState3, 2),
    rowList = _useState4[0],
    setRowList = _useState4[1];
  var _useState5 = useState(true),
    _useState6 = _slicedToArray(_useState5, 2),
    loading = _useState6[0],
    setLoading = _useState6[1];
  var _useState7 = useState(false),
    _useState8 = _slicedToArray(_useState7, 2),
    fail = _useState8[0],
    setFail = _useState8[1];
  var _useState9 = useState(nodeData.columnRules || []),
    _useState10 = _slicedToArray(_useState9, 2),
    rules = _useState10[0],
    setRules = _useState10[1];
  var _useState11 = useState(false),
    _useState12 = _slicedToArray(_useState11, 2),
    rulesInvalid = _useState12[0],
    setRulesInvalid = _useState12[1];
  useEffect(function () {
    queryColumnList();
  }, []);
  useEffect(function () {
    // 校验节点表单数据合法性
    checkForm();
  }, [rules, rowList, rulesInvalid]);
  function checkForm() {
    node.updateData({
      status: rulesInvalid || rowList.length === 0 ? 'failed' : 'success',
      columnList: rowList,
      columnRules: rules
    });
  }
  function queryColumnList() {
    setLoading(true);
    setFail(false);
    VisualStore.queryDatasetInfo(nodeData.datasetId).then(function (list) {
      setColumnList(list);
    }).catch(function (error) {
      setFail(true);
      console.error('获取字段列表失败', error);
    }).finally(function () {
      setLoading(false);
    });
  }
  if (fail) {
    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix
    }, /*#__PURE__*/React.createElement(Result, {
      className: "".concat(classPrefix, "-error"),
      status: "error",
      subTitle: "\u6570\u636E\u83B7\u53D6\u5931\u8D25",
      extra: /*#__PURE__*/React.createElement(Button, {
        onClick: queryColumnList,
        type: "primary"
      }, "\u91CD\u65B0\u52A0\u8F7D")
    }));
  }
  if (loading) {
    return /*#__PURE__*/React.createElement(ConfigLoading, null);
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-columns")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u4FDD\u7559\u5B57\u6BB5"), /*#__PURE__*/React.createElement("span", null, "\u5171\u8BA1", columnList.length, "\u6761\uFF0C\u5DF2\u9009\u62E9", /*#__PURE__*/React.createElement("span", {
    className: "".concat(classPrefix, "-count")
  }, rowList.length), "\u6761")), /*#__PURE__*/React.createElement(SimpleColumnTable, {
    readonly: false,
    columnList: columnList,
    chosenColumnList: rowList,
    onSelectColumn: setRowList
  })), /*#__PURE__*/React.createElement(ColumnRuleList, {
    loading: false,
    columnList: columnList,
    className: "".concat(classPrefix, "-rules"),
    rules: rules,
    dbType: "",
    onChange: setRules,
    onFail: setRulesInvalid
  }));
};
export default TableConfig;